## Script (Python) "getLinksBySubject"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=subject=[None,], sortorder=None, sorton=None
##title=Filter the Links and Favorites by subject
##
# Subject should be a tuple of keywords or None.
# The 'Subject' operator is 'AND'!

lfolderpath = '/'.join(context.getPhysicalPath())
try: 
   subject = tuple(subject)
except:
   subject=(None,)

if subject == (None,) or subject == ('',):
   links = container.portal_catalog.searchResults(portal_type=['Link','Favorite'],
                                     sort_on=sorton,
                                     sort_order=sortorder,
                                     path=lfolderpath)
else:
    links =  container.portal_catalog.searchResults(portal_type=['Link','Favorite'],
                                     sort_on=sorton,
                                     sort_order=sortorder,
                                     path=lfolderpath,
                                     Subject={'query' : subject, 
                                              'operator' : 'and'})
return links
