## Script (Python) "bookmarkAdd"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=remote_url, id='', title=None, description=None, subject=None, keywords=None
##title=Add a Bookmark
##
# Import a standard function, and get the HTML request and response objects.
from Products.PythonScripts.standard import html_quote
request = container.REQUEST
RESPONSE =  request.RESPONSE

context.invokeFactory( 'Link', id=id, title=title, remote_url=remote_url, description=description)
view_url = '%s/%s' % (context.absolute_url(),
                      context.getTypeInfo().getActionById('view')
                     )
new_link = getattr(context, id)
try:
    new_keywords = tuple(keywords.split(' '))
except:
    new_keywords = None
try:
   new_link.setSubject(new_keywords)
   new_link.reindexObject()
except:
   pass


msg = 'portal_status_message=\'%s\' has been added as a Bookmark' % title
return RESPONSE.redirect('%s?%s' % (view_url, msg))
