## Script (Python) "getLinkSubjects"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=get the subjects for Links and Favorites in this context
##
lfolderpath = context.getPhysicalPath()
links = container.portal_catalog.searchResults(portal_type=['Link','Favorite'], path='/'.join(lfolderpath))
# Use dictionary keys to get unique values
subjects = {}
for link in links:
     subjs = link.Subject
     for subj in subjs:
         subjects[subj] = None
subjs = subjects.keys()
subjs.sort()
return subjs
